#include <stdlib.h>
#include <stdio.h>
#include <stdalign.h>

#include "cmnLoops.h"

struct data{
    alignas(32) double vec[SIZE];
};


void optimizedLoop(struct data * restrict a, struct data * restrict b)
{
    // Uncomment to compile with clang
    // #pragma clang loop vectorize(enable)
    for (int i = 0; i < SIZE; i++) {
        a->vec[i] += b->vec[i];
    }
}



int main(void)
{
    struct data * a = (struct data *) aligned_alloc(32, sizeof(struct data));
    struct data * b = (struct data *) aligned_alloc(32, sizeof(struct data));

    for (size_t i = 0; i < SIZE; i++) {
        a->vec[i] = 1.0;
        b->vec[i] = 1.0;
    }

    uint64_t t0, t1;
    t0 = rdtscp();
    optimizedLoop(a,b);
    t1 = rdtscp();

    printf("%" PRIu64 "\n", t1-t0);


    double d = 0;
    for (size_t i = 0; i < SIZE; i++) {
        d += a->vec[i];
    }

    free(a);
    free(b);
    return (int) d;
}
